%{!?upstream_version: %global upstream_version %{version}%{?milestone}}

# Python3 support in OpenStack starts with version 3.5,
# which is only in Fedora 24+
%if 0%{?fedora} >= 24
%global with_python3 1
%endif


%global library os-vif
%global module os_vif

Name:       python-%{library}
Version:    1.2.1
Release:    4%{?dist}
Provides:    python2-os-vif = %{version}-%{release}
Summary:    OpenStack os-vif library
License:    ASL 2.0
URL:        http://launchpad.net/%{library}/

Source0:    http://tarballs.openstack.org/%{library}/%{module}-%{upstream_version}.tar.gz

# patches_ignore=DROP-IN-RPM
# patches_base=1.2.1
#
Patch0001: 0001-os-vif-add-vif_name-to-VIFVHostUser-class.patch
Patch0002: 0002-os-vif-add-new-port-profiles-to-enable-fast-path-vho.patch
Patch0003: 0003-Adds-Windows-support-for-OvsPlugin.patch
Patch0004: 0004-Add-MTU-to-Network-model-and-use-it-in-plugging.patch
Patch0005: 0005-add-support-for-vhost-user-reconnect.patch
Patch0006: 0006-remove-use-of-contextlib-and-with-nested.patch
Patch0007: 0007-vif_plug_ovs-Always-set-MTU-when-plugging-devices.patch
Patch0008: 0008-introduces-MTU-support-for-vhost-user.patch
Patch0009: 0009-ovs-hybrid-should-permanently-keep-MAC-entries.patch
Patch0010: 0010-ovs-do-not-delete-port-if-already-exists.patch

BuildArch:  noarch

Requires:   python-pbr >= 1.6
Requires:   python-netaddr >= 0.7.12
Requires:   python-oslo-config >= 2:3.14.0
Requires:   python-oslo-log >= 1.14.0
Requires:   python-oslo-i18n >= 2.1.0
Requires:   python-oslo-privsep >=  1.9.0
Requires:   python-oslo-versionedobjects >= 1.13.0
Requires:   python-six >= 1.9.0
Requires:   python-stevedore >= 1.16.0
Requires:   python-oslo-concurrency >= 3.11.0
BuildRequires:  python2-devel
BuildRequires:  python-pbr
BuildRequires:  python-setuptools
BuildRequires:  git
BuildRequires:  python-hacking
BuildRequires:  python-coverage
BuildRequires:  python-subunit
BuildRequires:  python-oslotest
BuildRequires:  python-testrepository
BuildRequires:  python-testscenarios
BuildRequires:  python-testtools
BuildRequires:  python-oslo-log
BuildRequires:  python-oslo-concurrency
BuildRequires:  python-oslo-privsep
BuildRequires:  python-oslo-versionedobjects
BuildRequires:  python-oslo-versionedobjects-tests
%package -n python-%{library}-tests
Provides: python2-%{library}-tests = %{version}-%{release}
Summary:    OpenStack os-vif library tests
Requires:   python-%{library} = %{version}-%{release}
Requires:   python-hacking
Requires:   python-coverage
Requires:   python-subunit
Requires:   python-oslotest
Requires:   python-testrepository
Requires:   python-testscenarios
Requires:   python-testtools
Requires:   python-oslo-versionedobjects-tests


%description -n python-%{library}-tests
A library for plugging and unplugging virtual interfaces in OpenStack.

This package contains the library test files.

%package -n python-%{library}-doc
Summary:    OpenStack os-vif library documentation

BuildRequires: python-sphinx
BuildRequires: python-oslo-sphinx
BuildRequires: python-reno

%description -n python-%{library}-doc
A library for plugging and unplugging virtual interfaces in OpenStack.

This package contains the documentation.

%if 0%{?with_python3}
%package -n python3-%{library}
Summary:    OpenStack os-vif library
%{?python_provide:%python_provide python3-%{library}}

BuildRequires:  python3-devel
BuildRequires:  python3-pbr
BuildRequires:  python3-setuptools
BuildRequires:  git
BuildRequires:  python3-hacking
BuildRequires:  python3-coverage
BuildRequires:  python3-subunit
BuildRequires:  python3-oslotest
BuildRequires:  python3-testrepository
BuildRequires:  python3-testscenarios
BuildRequires:  python3-testtools
BuildRequires:  python3-oslo-log
BuildRequires:  python3-oslo-concurrency
BuildRequires:  python3-oslo-privsep
BuildRequires:  python3-oslo-versionedobjects
BuildRequires:  python3-oslo-versionedobjects-tests

Requires:   python3-pbr >= 1.6
Requires:   python3-netaddr >= 0.7.12
Requires:   python3-oslo-config >= 2:3.14.0
Requires:   python3-oslo-log >= 1.14.0
Requires:   python3-oslo-i18n >= 2.1.0
Requires:   python3-oslo-privsep >=  1.9.0
Requires:   python3-oslo-versionedobjects >= 1.13.0
Requires:   python3-six >= 1.9.0
Requires:   python3-stevedore >= 1.16.0
Requires:   python3-oslo-concurrency >= 3.11.0

%description -n python3-%{library}
A library for plugging and unplugging virtual interfaces in OpenStack.

%package -n python3-%{library}-tests
Summary:    OpenStack os-vif library tests
Requires:   python3-%{library} = %{version}-%{release}
Requires:   python3-hacking
Requires:   python3-coverage
Requires:   python3-subunit
Requires:   python3-oslotest
Requires:   python3-testrepository
Requires:   python3-testscenarios
Requires:   python3-testtools
Requires:   python3-oslo-versionedobjects-tests


%description -n python3-%{library}-tests
A library for plugging and unplugging virtual interfaces in OpenStack.

This package contains the library test files.

%endif # with_python3


%description
A library for plugging and unplugging virtual interfaces in OpenStack.

%prep
%autosetup -n %{module}-%{upstream_version} -S git

# Let's handle dependencies ourseleves
rm -f *requirements.txt

%build
CFLAGS="%{optflags}" %{__python} setup.py %{?py_setup_args} build --executable="%{__python2} -s"
%if 0%{?with_python3}
%py3_build
%endif

# generate html docs
sphinx-build doc/source html
# remove the sphinx-build leftovers
rm -rf html/.{doctrees,buildinfo}

%install
CFLAGS="%{optflags}" %{__python} setup.py %{?py_setup_args} install -O1 --skip-build --root %{buildroot}
%if 0%{?with_python3}
%py3_install
%endif

%check
%if 0%{?with_python3}
%{__python3} setup.py test
rm -rf .testrepository
%endif
%{__python2} setup.py test

%files -n python-%{library}
%license LICENSE
%{python2_sitelib}/%{module}
%{python2_sitelib}/vif_plug_linux_bridge
%{python2_sitelib}/vif_plug_ovs
%{python2_sitelib}/%{module}-*.egg-info
%exclude %{python2_sitelib}/*/tests

%files -n python-%{library}-tests
%license LICENSE
%{python2_sitelib}/*/tests

%files -n python-%{library}-doc
%license LICENSE
%doc html README.rst

%if 0%{?with_python3}
%files -n python3-%{library}
%license LICENSE
%{python3_sitelib}/%{module}
%{python3_sitelib}/vif_plug_linux_bridge
%{python3_sitelib}/vif_plug_ovs
%{python3_sitelib}/%{module}-*.egg-info
%exclude %{python3_sitelib}/*/tests

%files -n python3-%{library}-tests
%license LICENSE
%{python3_sitelib}/*/tests
%endif # with_python3

%changelog
* Tue Mar 06 2018 Sahid Orentino Ferdjaoui <sahid.ferdjaoui@redhat.com> 1.2.1-4
- ovs: do not delete port if already exists (rhbz#1547274)

* Thu Sep 21 2017 Sahid Orentino Ferdjaoui <sahid.ferdjaoui@redhat.com> 1.2.1-3
- ovs-hybrid: should permanently keep MAC entries (rhbz#1494031)

* Mon Jul 31 2017 Sahid Orentino Ferdjaoui <sahid.ferdjaoui@redhat.com> 1.2.1-2
- introduces MTU support for vhost-user (rhbz#1447081)
- vif_plug_ovs: Always set MTU when plugging devices
- remove use of contextlib and with nested (rhbz#1447081)
- add support for vhost-user reconnect (rhbz#1447081)
- Add MTU to Network model and use it in plugging (rhbz#1447081)
- Adds Windows support for OvsPlugin (rhbz#1447081)
- os-vif: add new port profiles to enable fast path vhostuser (rhbz#1471657)
- os-vif: add vif_name to VIFVHostUser class (rhbz#1471657)

* Wed Sep 14 2016 Haikel Guemar <hguemar@fedoraproject.org> 1.2.1-1
- Update to 1.2.1

